/* 
 * File:   ledctrl.h
 * Author: dt
 *
 * Created on 18. Januar 2021, 10:21
 */

#ifndef LEDCTRL_H
#define	LEDCTRL_H
#include "mcc_generated_files/mcc.h"

#ifdef	__cplusplus
extern "C" {
#endif

#define LEDINVERT (1)
#define LEDSTRAIGHT (0)

typedef struct {
    char lowActive;
    char invertFlash;
    unsigned long flashTime;
    unsigned long currentFlashTime;
    
    unsigned long blinkOnTime;
    unsigned long blinkOffTime;
    unsigned long currentBlinkTime;    
    
    char state;  // logical state of led 1=on, 0=off
} ledCtrlType;


void ledInit(ledCtrlType* led,char lowActive);
void ledSetFlashTime(ledCtrlType* led,unsigned long flashTime);
void ledTriggerFlash(ledCtrlType* led);
void ledTriggerFlashInvert(ledCtrlType* led);

__bit ledOn(ledCtrlType* led);
__bit ledOff(ledCtrlType* led);
void ledSetBlinkTimes(ledCtrlType* led,unsigned long on,unsigned long off);
void ledTriggerBlink(ledCtrlType* led);

__bit ledState(ledCtrlType* led);
void ledHop(ledCtrlType* led, unsigned long hop);
__bit ledTick(ledCtrlType* led);




#ifdef	__cplusplus
}
#endif

#endif	/* LEDCTRL_H */

