#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/uart1.h"
#include "mcc_generated_files/uart2.h"
#include "mcc_generated_files/uart4.h"
#include "mcc_generated_files/uart5.h"

#include "ledctrl.h"
#include "spi.h"
#include "uarts.h"
#include "leds.h"

#define LED_FLASHTIME (50000)

/*
                         Main application
 */
void main(void)
{       
    // Initialize the device
    SYSTEM_Initialize();
    
    // PPS for the UARTS
    // RC0 > RX1
    // RC1 > TX1
    // RC2 > RX2
    // RC3 > TX2
    // RB1 > TX3
    // RB0 > RX3
    // RC5 > TX4
    // RC4 > RX4
    
    //RB4 = SDO
    //RB3 = SDI
    //RB2 = CLK
    
    // A0..A3 LEDS
    
    ledInit(&ledU1,LEDINVERT);
    ledInit(&ledU2,LEDINVERT);
    ledInit(&ledU3,LEDINVERT);
    ledInit(&ledU4,LEDINVERT);
    
    LEDU1=ledOn(&ledU1);
    LEDU2=ledOn(&ledU2);
    LEDU3=ledOn(&ledU3);
    LEDU4=ledOn(&ledU4);
    
    __delay_ms(1000);
    
    LEDU1=ledOff(&ledU1);
    LEDU2=ledOff(&ledU2);
    LEDU3=ledOff(&ledU3);
    LEDU4=ledOff(&ledU4);
        
    ledSetFlashTime(&ledU1,LED_FLASHTIME);
    ledSetFlashTime(&ledU2,LED_FLASHTIME);
    ledSetFlashTime(&ledU3,LED_FLASHTIME);  
    ledSetFlashTime(&ledU4,LED_FLASHTIME);
            
    uartsInit();
    
    spiInit();
    spiSetTranferCompleteHandler(copyToFifos );

    INTERRUPT_Initialize();
    INTERRUPT_GlobalInterruptEnable();
    
    while (1)
    {        
        LEDU1=ledTick(&ledU1);              
        LEDU2=ledTick(&ledU2);
        LEDU3=ledTick(&ledU3);
        LEDU4=ledTick(&ledU4);
    }
}
/**
 End of File
*/